package com.ejie.ab63.dao;

import java.util.List;

import com.ejie.ab63.model.Habitacion;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * Ab6322s00Dao  
 * 
 *  
 */

public interface HabitacionDao {

	/**
	 * Inserts a single row in the Ab6322s00 table.
	 *
	 * @param ab6322s00
	 *            Ab6322s00
	 * @return Ab6322s00
	 */
	Habitacion add(Habitacion ab6322s00);

	/**
	 * Updates a single row in the Ab6322s00 table.
	 *
	 * @param ab6322s00
	 *            Ab6322s00
	 * @return Ab6322s00
	 */
	Habitacion update(Habitacion ab6322s00);

	/**
	 * Finds a single row in the Ab6322s00 table.
	 *
	 * @param ab6322s00
	 *            Ab6322s00
	 * @return Ab6322s00
	 */
	Habitacion find(Habitacion ab6322s00);

	/**
	 * Removes a single row in the Ab6322s00 table.
	 *
	 * @param ab6322s00
	 *            Ab6322s00
	 */
	void remove(Habitacion ab6322s00);

	/**
	 * Finds a List of rows in the Ab6322s00 table.
	 *
	 * @param ab6322s00
	 *            Ab6322s00
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List
	 */
	List<Habitacion> findAll(Habitacion ab6322s00, TableRequestDto tableRequestDto);

	/**
	 * Finds rows in the Ab6322s00 table using like.
	 *
	 * @param ab6322s00
	 *            Ab6322s00
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Habitacion> findAllLike(Habitacion ab6322s00, TableRequestDto tableRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the Ab6322s00 table.
	 *
	 * @param filterAb6322s00
	 *            Ab6322s00
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Habitacion filterAb6322s00, TableRequestDto tableRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the Ab6322s00 table using like.
	 *
	 * @param ab6322s00
	 *            Ab6322s00
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(Habitacion ab6322s00, Boolean startsWith);

	/**
	 * Counts rows in the Ab6322s00 table.
	 *
	 * @param ab6322s00
	 *            Ab6322s00
	 * @return Long
	 */
	Long findAllCount(Habitacion ab6322s00);

	/**
	 * Reorder selection.
	 *
	 * @param filterAb6322s00
	 *            Ab6322s00
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Ab6322s00>>
	 */
	List<TableRowDto<Habitacion>> reorderSelection(Habitacion filterAb6322s00, TableRequestDto tableRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterAb6322s00
	 *            Ab6322s00
	 * @param searchAb6322s00
	 *            Ab6322s00
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Ab6322s00>>
	 */
	List<TableRowDto<Habitacion>> search(Habitacion filterAb6322s00, Habitacion searchAb6322s00,
			TableRequestDto tableRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical Ab6322s00 table.
	 *
	 * @param filterAb6322s00
	 *            Ab6322s00
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<Ab6322s00>>
	 */
	List<JerarquiaDto<Habitacion>> findAllLikeJerarquia(Habitacion filterAb6322s00, TableRequestDto tableRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterAb6322s00
	 *            Ab6322s00
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(Habitacion filterAb6322s00, TableRequestDto tableRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterAb6322s00
	 *            Ab6322s00
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<Ab6322s00>>
	 */
	List<TableRowDto<Habitacion>> findAllChild(Habitacion filterAb6322s00, TableRequestDto tableRequestDto);

	Long getTotalHabitacionesByIdEstablecimiento(Habitacion habitacion);

	Long getTotalHabDblByIdEst(Integer idEstablecimiento);

	Long getTotalHabDblCsByIdEst(Integer idEstablecimiento);

	Long getTotalHabIndByIdEst(Integer idEstablecimiento);

	Long getTotalHabMultiplesByIdEst(Integer idEstablecimiento);

	Long getTotalUnidadesResumen(Integer idEstablecimiento);

	Long getTotalUnidadesDetalle(Integer idEstablecimiento);

	Long getTotalPlazasResumen(Integer idEstablecimiento);

	Long getTotalPlazasDetalle(Integer idEstablecimiento);

}
